#pragma once

#include <osmocom/abis/lapd.h>

struct lapv5_instance {
	struct llist_head list;		/* list of LAPV5 instances */
	bool network_side;

	void (*transmit_cb)(struct msgb *msg, void *cbdata);
	void *transmit_cbdata;
	void (*receive_cb)(struct osmo_dlsap_prim *odp, uint16_t dladdr, void *rx_cbdata);
	void *receive_cbdata;

	struct lapd_profile profile;	/* must be a copy */

	struct llist_head sap_list;	/* list of SAP/datalinks in this instance */
	int pcap_fd;			/* PCAP file descriptor */
	char *name;			/* human-readable name */
};

int lapv5ef_rx(struct v5x_link *link, struct msgb *msg);
